/*
 * Copyright (c) 2018 STMicroelectronics
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <stdio.h>
#include <zephyr.h>
#include <device.h>
#include <drivers/sensor.h>
#include <drivers/gpio.h>
#include <drivers/i2c.h>
#include <kernel.h>
#include <sys/util.h>
#include <sys/printk.h>
#include <inttypes.h>
#include <drivers/spi.h>
#include "lsm6dsox.h"
const struct device *i2c_dev0;
const struct device *i2c_dev;
const struct device *i2c_dev2;
const struct device *i2c_dev3;

const struct device *gpio_dev_AMS_CS;
const struct device *gpio_dev_CS;
const struct device *gpio_dev_SDA;
const struct device *gpio_dev__SCL;

int I2C_Driver_Init()
{

  gpio_dev_CS = device_get_binding("GPIO_0");
  gpio_pin_configure(gpio_dev_CS, 05, GPIO_OUTPUT); 
  gpio_pin_set(gpio_dev_CS, 05, 1);

  gpio_dev_AMS_CS = device_get_binding("GPIO_0");
  gpio_pin_configure(gpio_dev_AMS_CS, 23, GPIO_OUTPUT); 
  gpio_pin_set(gpio_dev_AMS_CS, 23, 1);


  gpio_dev_SDA = device_get_binding("GPIO_0");
  gpio_pin_configure(gpio_dev_SDA, 32, GPIO_OUTPUT); 
  gpio_pin_set(gpio_dev_SDA, 32, 1);
    

   gpio_dev__SCL = device_get_binding("GPIO_0");
  gpio_pin_configure(gpio_dev__SCL, 33, GPIO_OUTPUT); 
  gpio_pin_set(gpio_dev__SCL, 33, 0);


  //i2c_dev0 = device_get_binding("I2C_0");
  //if (!i2c_dev0) 
  //{
  //  printk("Binding failed I2C_0.");
  //  return 0;
  //}

  i2c_dev = device_get_binding("I2C_1");

  if (!i2c_dev) 
  {
    printk("Binding failed I2C_1.");
    return 0;
  }

  i2c_dev2 = device_get_binding("I2C_2");

  if (!i2c_dev2)
  {
    printk("Binding failed I2C_2.");
    return 0;
  }

  i2c_dev3 = device_get_binding("I2C_3");

  if (!i2c_dev3) 
  {
    printk("Binding failed I2C_3.");
    return 0;
  }

  return 0;
}

void I2C_Scan_Address()
{
 int error = 0;
  for (uint8_t i = 2; i <= 127; i++) 
  {
    uint8_t dst = 1;

    //error = i2c_write(i2c_dev0, &dst, 1, i);

    //if (error == 0) 
    //{
    //  printk("i2c_dev0 0x%2x FOUND\n", i);
    //}

    error = i2c_write(i2c_dev, &dst, 1, i);

    if (error == 0) 
    {
      printk("i2c_dev 0x%2x FOUND\n", i);
    }

    error = i2c_write(i2c_dev2, &dst, 1, i);

    if (error == 0) 
    {
      printk("i2c_dev2  0x%2x FOUND\n", i);
    }

    error = i2c_write(i2c_dev3, &dst, 1, i);

    if (error == 0)               
    {
      printk("i2c_dev3  0x%2x FOUND\n", i);
    }
  }

  printk("Scanning done\n");
}
void main(void)
{
	
I2C_Driver_Init();
 k_sleep(K_MSEC(100));
I2C_Scan_Address();
create_imu_monitoring_thread();
 while(1)
 {
		k_sleep(K_MSEC(2000));
                I2C_Scan_Address();
	}
}
